%define cvs	20050801

Summary: 	Digital VCR and streaming server
Name: 		ffmpeg
Version: 	0.4.9
Release: 	0.%{cvs}.%{mysig}
Epoch: 		0
License: 	GPL
Group: 		Applications/Multimedia
URL: 		http://ffmpeg.sourceforge.net/
Source0: 	http://www2.mplayerhq.hu/MPlayer/cvs/FFMpeg-%{cvs}.tar.bz2
Patch0:		ffmpeg-0.4.9-20050801-avoid-functions.patch
Patch1:		ffmpeg-0.4.9-20050427-a52link.patch
Patch2:		ffmpeg-0.4.9-20050801-pkgconfig.patch
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires:	zlib-devel lame-devel libvorbis-devel faad2-devel 
BuildRequires:	xvidcore-devel SDL-devel a52dec-devel gsm-devel
BuildRequires:	imlib2-devel /usr/bin/texi2html libtheora-devel
BuildRequires:	sed >= 3.95
%if 0%{!?_without_faac:1}
BuildRequires:	faac-devel
%endif
Obsoletes:	libpostproc < 0:1.0-0.lvn.0.14

%ifarch x86_64 
Requires:       libfaad.so.0()(64bit)
Requires:       liba52.so.0()(64bit)
Provides:	libavcodec.so()(64bit) libavformat.so()(64bit)
%else
Requires:       libfaad.so.0
Provides:	libavcodec.so libavformat.so
%endif

%package devel
Summary: 	Development package for %{name}
Group: 		Development/Libraries
Requires: 	%{name} = %{epoch}:%{version}-%{release}
Requires: 	pkgconfig

# ----------------------------------------------------------------------------

%description
FFMpeg is a complete and free Internet live audio and video
broadcasting solution for Linux/Unix. It also includes a digital
VCR. It can encode in real time in many formats including MPEG1 audio
and video, MPEG4, h263, ac3, asf, avi, real, mjpeg, and flash.

%description devel
FFMpeg is a complete and free Internet live audio and video
broadcasting solution for Linux/Unix. It also includes a digital
VCR. It can encode in real time in many formats including MPEG1 audio
and video, MPEG4, h263, ac3, asf, avi, real, mjpeg, and flash.
This package contains development files for %{name}

# ----------------------------------------------------------------------------

%prep
%setup -q -n FFMpeg-%{cvs}
%patch0 -p1 -b .avoid
%patch1 -p0 -b .a52link
%patch2 -p0 -b .pkgconfig
sed -i -e 's|gsm.h|gsm/gsm.h|' libavcodec/libgsm.c # ugh

# ----------------------------------------------------------------------------

%build
%configure \
%ifarch %{ix86} ia64
  --cpu=x86 \
  --extra-cflags="%{optflags}" \
%endif
%ifarch x86_64
  --cpu=x86_64 \
  --extra-cflags="%{optflags} -fPIC" \
  --disable-mmx \
%endif
%ifarch ppc
  --cpu=powerpc \
  --extra-cflags="%{optflags} -fPIC" \
%endif
  --enable-mp3lame \
  --enable-libogg \
  --enable-vorbis \
  --enable-theora \
  --enable-faad \
  --enable-faadbin \
%if 0%{!?_without_faac:1}
  --enable-faac \
%endif
  --enable-libgsm \
  --enable-xvid \
  --enable-a52 \
  --enable-a52bin \
  --enable-pp \
  --enable-shared-pp \
  --enable-shared \
  --enable-gpl \
  --disable-debug \
  --disable-opts \
  --disable-strip

make -C libavcodec/libpostproc # yuck
make %{?_smp_mflags} 

# ----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT __doc
%makeinstall # no DESTDIR support
cp -a doc __doc
rm -f __doc/{Makefile,*.{1,pl,texi}}

# ----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# ----------------------------------------------------------------------------

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc COPYING CREDITS Changelog README __doc/*.*
%{_bindir}/ffmpeg
%{_bindir}/ffserver
%{_bindir}/ffplay
%{_libdir}/vhook
%{_libdir}/libavcodec*.so
%{_libdir}/libavformat*.so
%{_libdir}/libpostproc.so.*
%{_mandir}/man1/*.1*

%files devel
%defattr(-,root,root,-)
# Note: as of 20050801, "configure" doesn't honor --includedir.
%{_prefix}/include/%{name}
%{_prefix}/include/postproc
%{_libdir}/libpostproc.so
%{_libdir}/pkgconfig/*.pc

# ----------------------------------------------------------------------------

%changelog
* Tue Sep 20 2005 Milan Kerslager <kerslage@linux.cz> 0.4.9-0.20050801.ker.rhel4
- rebuild for RHEL4 (package from http://rpm.livna.org/fedora/4/i386/SRPMS.lvn)

* Tue Aug 16 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.4.9-0.lvn.0.18.20050801
- Apply some upstream and some mine (libdir) fixes to pkgconfig files.
- Add pkgconfig dependency to -devel.
- Include gsm support.

* Thu Aug 4 2005 David Woodhouse <dwmw2@infradead.orG> - 0:0.4.9-0.lvn.0.17.20050801
- Update to 20050801 snapshot to make xine-lib happy
- Enable Altivec support by using --cpu=powerpc (not 'ppc')
- Enable theora
- Add pkgconfig files
- Undefine various things which might be macros before redefining them

* Sat Jul 23 2005 Dams <anvil[AT]livna.org> - 0:0.4.9-0.lvn.0.17.20050427
- Added patch from Marc Deslauriers to fix wmv2 distorsion

* Sun Jul 10 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.4.9-0.lvn.0.16.20050427
- Enable faac by default, rebuild with "--without faac" to disable.
- Clean up obsolete pre-FC2 and other stuff.

* Sun May 22 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.4.9-0.lvn.0.15.20050427
- PPC needs -fPIC too.

* Sat May 21 2005 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:0.4.9-0.lvn.0.14.20050427
- disable mmx for now on x86_64 to fix build

* Sat Apr 30 2005 Dams <anvil[AT]livna.org> - 0:0.4.9-0.lvn.0.13.20050427
- Removed bogus devel requires
- Re-added conditionnal a52dec buildreq

* Fri Apr 29 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.4.9-0.lvn.0.12.20050427
- Link avcodec with a52 when building with a52bin, remove unnecessary
  hardcoded liba52.so.0 dependency.

* Fri Apr 29 2005 Dams <anvil[AT]livna.org> - 0:0.4.9-0.lvn.0.11.20050427
- Fixed devel package deps

* Fri Apr 29 2005 Dams <anvil[AT]livna.org> - 0:0.4.9-0.lvn.0.10.20050427
- texi2html replaces tetex as build dependency (FC4 compliance)
- re-added man pages

* Thu Apr 28 2005 Dams <anvil[AT]livna.org> - 0:0.4.9-0.lvn.0.9.20050427
- Patch from Enrico to fix build on gcc4
- Missing BuildReq a52dec-devel when a52bin is defined
- Patch to fix a52 build

* Wed Apr 27 2005 Dams <anvil[AT]livna.org> - 0:0.4.9-0.lvn.0.8.20050427
- Updated tarball to cvs 20050427 snapshot
- Enabled libogg, xvid, a52bin
- Dropped Patch[0-3]

* Thu Dec 30 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:0.4.9-0.lvn.0.7.pre1
- honor optflags with configure option extra-cflags 
- disable-mmx on x86_64 and use -fPIC (suggested by compile error...)
- add patch so install directorys like lib64 are correct on x86_64
- Require/Provide explicit 64bit libs when building for x86_64

* Sat Nov 13 2004 Dams <anvil[AT]livna.org> - 0:0.4.9-0.lvn.0.6.pre1
- Applied patch to fix gcc-3.4 building issue

* Sat Sep 11 2004 Ville Skyttä <ville.skytta at iki.fi> 0:0.4.9-0.lvn.0.5.pre1
- Bundle libpostproc in the "main" packages (bug 255).

* Thu Sep  2 2004 Ville Skyttä <ville.skytta at iki.fi> 0:0.4.9-0.lvn.0.4.pre1
- Avoid RPATH from sdl-config on < FC2.

* Thu Sep  2 2004 Ville Skyttä <ville.skytta at iki.fi> 0:0.4.9-0.lvn.0.3.pre1
- Don't disable MMX explicitly on any arch, it seems to be detected at runtime.
- Pass explicit cpu=x86 to configure for ix86, x86_64 and ia64.
- Unset CFLAGS before running make to work around a make < 3.80 bug (bug 255).
- BuildRequire tetex; texi2html is needed to build the docs.

* Tue Aug 31 2004 Ville Skyttä <ville.skytta at iki.fi> 0:0.4.9-0.lvn.0.2.pre1
- Try to be sure to link with libpostproc from this source tree (bug 255).
- Exclude *.texi from docs.

* Thu Jul 29 2004 Ville Skyttä <ville.skytta at iki.fi> 0:0.4.9-0.lvn.0.1.pre1
- Update to 0.4.9-pre1, libpostproc moves here.
- Change license to GPL due to GPL'd parts being included.
- Disable runtime dlopen()'d liba52, it's currently broken.
- Honor $RPM_OPT_FLAGS (--disable-debug, --disable-opts).
- Really prevent stripping in "make install".
- Update list of archs that have MMX.

* Fri May 21 2004 Dams <anvil[AT]livna.org> - 0:0.4.8-0.lvn.5
- Added URL in Source0

* Sun Nov 23 2003 Dams <anvil[AT]livna.org> 0:0.4.8-0.lvn.4
- BuildRequires:imlib2-devel

* Sat Oct 18 2003 Dams <anvil[AT]livna.org> 0:0.4.8-0.fdr.3
- Rebuild

* Thu Oct 16 2003 Dams <anvil[AT]livna.org> 0:0.4.8-0.fdr.2
- Re-added Provides for libavcodec.so and libavformat.so

* Thu Oct 16 2003 Dams <anvil[AT]livna.org> 0:0.4.8-0.fdr.1
- Include more docs

* Mon Oct 13 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.4.8-0.fdr.1
- Update to 0.4.8.

* Sun Sep 28 2003 Dams <anvil[AT]livna.org> 0:0.4.7-0.fdr.0.1.cvs20030712
- Removed comment after scriptlets

* Mon Jul 14 2003 Dams <anvil[AT]livna.org> 0:0.4.7-0.fdr.0.0.cvs20030712
- Applied spec file patch from Ville Skyttä (bug #448 comment #6)
- Added Provides:libavformat.so
- Added libavformat in file section

* Sat Jul 12 2003 Dams <anvil[AT]livna.org> 0:0.4.7-0.fdr.0.0.cvs20030712
- Updated snapshot

* Tue Jul  8 2003 Dams <anvil[AT]livna.org> 0:0.4.7-0.fdr.0.0.cvs20030707
- Updated to cvs version 20030707
- Updated patch to not strip binaries
- Temporary disabling MMX as it make the build failed
- Added missing unowned directory
- Removed URL in Source0

* Sun May 18 2003 Dams <anvil[AT]livna.org> 0:0.4.6-0.fdr.4
- Removed BuildRequires for a52dec-devel
- Added Requires a52dec
- Change License

* Sat May 10 2003 Dams <anvil[AT]livna.org> 0:0.4.6-0.fdr.3
- Changed url in Source0
- Dont strip binaries/libraries
- Dont include doc/Makefile

* Sat May 10 2003 Dams <anvil[AT]livna.org> 0:0.4.6-0.fdr.2
- post/postun scriplets
- Now providing libavcodec.so

* Sat May 10 2003 Dams <anvil[AT]livna.org> 
- Initial build.
